import React from 'react';
import PropTypes from 'prop-types';
import { createUseStyles } from "react-jss/dist/react-jss.esm.js";
var useStyles = createUseStyles({
  helperTextStyle: {
    color: '#da1e28',
    display: 'block',
    overflow: 'initial'
  }
});

var HelperTextBlock = function HelperTextBlock(_ref) {
  var helperText = _ref.helperText,
      errorText = _ref.errorText,
      warnText = _ref.warnText;

  var _useStyles = useStyles(),
      helperTextStyle = _useStyles.helperTextStyle;

  if (errorText) {
    return /*#__PURE__*/React.createElement("div", {
      className: "bx--form-requirement ddorg__carbon-error-helper-text ".concat(helperTextStyle)
    }, errorText);
  }

  if (warnText) {
    return /*#__PURE__*/React.createElement("div", {
      className: "bx--form-requirement ddorg__carbon-error-helper-text ".concat(helperTextStyle)
    }, warnText);
  }

  if (helperText) {
    return /*#__PURE__*/React.createElement("div", {
      className: "bx--form__helper-text"
    }, helperText);
  }

  return null;
};

HelperTextBlock.propTypes = {
  helperText: PropTypes.node,
  errorText: PropTypes.node,
  warnText: PropTypes.node
};
export default HelperTextBlock;