"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.buildLabel = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _withDescription = _interopRequireDefault(require("../with-description"));

var _isRequired = _interopRequireDefault(require("../is-required/is-required"));

var _excluded = ["isDisabled", "isReadOnly", "isRequired", "label", "description"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var buildLabel = function buildLabel(label, isRequired) {
  return label && (isRequired ? /*#__PURE__*/_react["default"].createElement(_isRequired["default"], null, label) : label) || undefined;
};

exports.buildLabel = buildLabel;

var prepareProps = function prepareProps(_ref) {
  var isDisabled = _ref.isDisabled,
      isReadOnly = _ref.isReadOnly,
      _ref$isRequired = _ref.isRequired,
      isRequired = _ref$isRequired === void 0 ? false : _ref$isRequired,
      label = _ref.label,
      description = _ref.description,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  return _objectSpread(_objectSpread({
    disabled: isDisabled,
    labelText: buildLabel(label, isRequired),
    readOnly: isReadOnly
  }, props), description ? {
    labelText: /*#__PURE__*/_react["default"].createElement(_withDescription["default"], {
      description: description,
      labelText: buildLabel(label || props.labelText, isRequired)
    })
  } : {});
};

var _default = prepareProps;
exports["default"] = _default;