"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _clsx = _interopRequireDefault(require("clsx"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _wizard = _interopRequireDefault(require("@data-driven-forms/common/wizard/wizard"));

var _formSpy = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/form-spy"));

var _wizardContext = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/wizard-context"));

var _carbonComponentsReact = require("carbon-components-react");

var _ProgressIndicator = require("carbon-components-react/lib/components/ProgressIndicator/ProgressIndicator");

var _excluded = ["stepsInfo", "jumpToStep"],
    _excluded2 = ["title"],
    _excluded3 = ["stepsInfo", "buttonLabels", "ButtonSetProps", "BackButtonProps", "NextButtonProps", "SubmitButtonProps", "ProgressIndicatorProps", "vertical", "WizardBodyProps", "conditionalSubmitFlag"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var useStyles = (0, _reactJssCjs.createUseStyles)({
  horizontalNav: {
    marginBottom: 48
  },
  buttonSet: {
    marginTop: 48,
    flexFirection: 'row-reverse',
    display: 'flex'
  },
  body: {
    '&>:not(:last-child)': {
      marginBottom: 32
    }
  }
});

var WizardNav = function WizardNav(_ref) {
  var stepsInfo = _ref.stepsInfo,
      jumpToStep = _ref.jumpToStep,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);

  var _useStyles = useStyles(),
      horizontalNav = _useStyles.horizontalNav;

  return /*#__PURE__*/_react["default"].createElement(_ProgressIndicator.ProgressIndicator, (0, _extends2["default"])({
    onChange: function onChange(index) {
      return props.currentIndex > index ? jumpToStep(index, true) : undefined;
    }
  }, props, {
    className: (0, _clsx["default"])(horizontalNav, props.className)
  }), stepsInfo.map(function (_ref2, index) {
    var title = _ref2.title,
        step = (0, _objectWithoutProperties2["default"])(_ref2, _excluded2);
    return /*#__PURE__*/_react["default"].createElement(_ProgressIndicator.ProgressStep, (0, _extends2["default"])({
      key: index,
      label: title,
      disabled: index > props.currentIndex
    }, step));
  }));
};

WizardNav.propTypes = {
  stepsInfo: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    title: _propTypes["default"].node
  })),
  currentIndex: _propTypes["default"].number,
  jumpToStep: _propTypes["default"].func,
  className: _propTypes["default"].string
};
var defaultLabels = {
  submit: 'Submit',
  back: 'Back',
  next: 'Next'
};

var Layout = function Layout(_ref3) {
  var nav = _ref3.nav,
      fields = _ref3.fields,
      WizardBodyProps = _ref3.WizardBodyProps;

  var _useStyles2 = useStyles(),
      body = _useStyles2.body;

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, nav, /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, WizardBodyProps, {
    className: (0, _clsx["default"])(body, WizardBodyProps === null || WizardBodyProps === void 0 ? void 0 : WizardBodyProps.className)
  }), fields));
};

Layout.propTypes = {
  nav: _propTypes["default"].node,
  fields: _propTypes["default"].node,
  WizardBodyProps: _propTypes["default"].object
};

var VerticalLayout = function VerticalLayout(_ref4) {
  var nav = _ref4.nav,
      fields = _ref4.fields,
      WizardBodyProps = _ref4.WizardBodyProps;

  var _useStyles3 = useStyles(),
      body = _useStyles3.body;

  return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Grid, {
    narrow: true
  }, /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Row, null, /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Column, {
    sm: 1,
    md: 2,
    lg: 3
  }, nav), /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Column, (0, _extends2["default"])({}, WizardBodyProps, {
    className: (0, _clsx["default"])(body, WizardBodyProps === null || WizardBodyProps === void 0 ? void 0 : WizardBodyProps.className)
  }), fields)));
};

VerticalLayout.propTypes = {
  nav: _propTypes["default"].node,
  fields: _propTypes["default"].node,
  WizardBodyProps: _propTypes["default"].object
};

var WizardInternal = function WizardInternal(_ref5) {
  var stepsInfo = _ref5.stepsInfo,
      buttonLabels = _ref5.buttonLabels,
      ButtonSetProps = _ref5.ButtonSetProps,
      BackButtonProps = _ref5.BackButtonProps,
      NextButtonProps = _ref5.NextButtonProps,
      SubmitButtonProps = _ref5.SubmitButtonProps,
      ProgressIndicatorProps = _ref5.ProgressIndicatorProps,
      vertical = _ref5.vertical,
      WizardBodyProps = _ref5.WizardBodyProps,
      conditionalSubmitFlag = _ref5.conditionalSubmitFlag,
      props = (0, _objectWithoutProperties2["default"])(_ref5, _excluded3);

  var _useContext = (0, _react.useContext)(_wizardContext["default"]),
      formOptions = _useContext.formOptions,
      currentStep = _useContext.currentStep,
      handlePrev = _useContext.handlePrev,
      onKeyDown = _useContext.onKeyDown,
      handleNext = _useContext.handleNext,
      activeStepIndex = _useContext.activeStepIndex,
      selectNext = _useContext.selectNext,
      jumpToStep = _useContext.jumpToStep;

  var _useStyles4 = useStyles(),
      buttonSet = _useStyles4.buttonSet;

  var finalButtoLabels = _objectSpread(_objectSpread({}, defaultLabels), buttonLabels);

  var nav = stepsInfo && /*#__PURE__*/_react["default"].createElement(WizardNav, (0, _extends2["default"])({
    vertical: vertical,
    stepsInfo: stepsInfo,
    currentIndex: activeStepIndex,
    jumpToStep: jumpToStep
  }, ProgressIndicatorProps));

  var fields = currentStep.fields.map(function (item) {
    return formOptions.renderForm([item], formOptions);
  });
  var WizardLayout = vertical && nav ? VerticalLayout : Layout;
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    onKeyDown: onKeyDown
  }, props), /*#__PURE__*/_react["default"].createElement(WizardLayout, {
    nav: nav ? nav : null,
    fields: fields,
    WizardBodyProps: WizardBodyProps
  }), /*#__PURE__*/_react["default"].createElement(_formSpy["default"], null, function (_ref6) {
    var invalid = _ref6.invalid,
        validating = _ref6.validating,
        submitting = _ref6.submitting;
    var nextResult = currentStep.nextStep ? selectNext(currentStep.nextStep, formOptions.getState) : currentStep.nextStep;
    var progressNext = nextResult !== conditionalSubmitFlag && currentStep.nextStep;
    return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, ButtonSetProps, {
      className: (0, _clsx["default"])(buttonSet, ButtonSetProps.className)
    }), progressNext ? /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Button, (0, _extends2["default"])({
      onClick: function onClick() {
        return handleNext(nextResult);
      },
      disabled: !formOptions.valid || invalid || validating || submitting
    }, NextButtonProps), finalButtoLabels.next) : /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Button, (0, _extends2["default"])({
      onClick: function onClick() {
        return formOptions.handleSubmit();
      },
      disabled: !formOptions.valid || invalid || validating || submitting
    }, SubmitButtonProps), finalButtoLabels.submit), /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Button, (0, _extends2["default"])({
      kind: "secondary",
      onClick: handlePrev,
      disabled: activeStepIndex === 0
    }, BackButtonProps), finalButtoLabels.back));
  }));
};

WizardInternal.propTypes = {
  stepsInfo: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    title: _propTypes["default"].node
  })),
  buttonLabels: _propTypes["default"].shape({
    submit: _propTypes["default"].node,
    back: _propTypes["default"].node,
    next: _propTypes["default"].node
  }),
  BackButtonProps: _propTypes["default"].object,
  NextButtonProps: _propTypes["default"].object,
  SubmitButtonProps: _propTypes["default"].object,
  ButtonSetProps: _propTypes["default"].object,
  ProgressIndicatorProps: _propTypes["default"].object,
  vertical: _propTypes["default"].bool,
  WizardBodyProps: _propTypes["default"].object,
  conditionalSubmitFlag: _propTypes["default"].string.isRequired
};
WizardInternal.defaultProps = {
  BackButtonProps: {},
  NextButtonProps: {},
  SubmitButtonProps: {},
  ButtonSetProps: {},
  ProgressIndicatorProps: {},
  WizardBodyProps: {}
};

var Wizard = function Wizard(props) {
  return /*#__PURE__*/_react["default"].createElement(_wizard["default"], (0, _extends2["default"])({
    Wizard: WizardInternal
  }, props));
};

var _default = Wizard;
exports["default"] = _default;